routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\AuthController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\UserController;
use App\Http\Controllers\HolidayController;
use App\Http\Controllers\DivisionController;


Route::group(['middleware' => 'auth'], function () {
    Route::get('home', [HomeController::class, 'index'])->name('home');

    // Logout
    Route::get('logout', [AuthController::class, 'logout'])->name('logout');

    // Divisions
    Route::resource('divisions', DivisionController::class);

    //Users
    Route::get('divisions/{division}/users', [Usercontroller::class, 'index'])->name('users.index');
    Route::get('divisions/{division}/users/create', [UserController::class, 'create'])->name('users.create');
    Route::post('divisions/{division}/users', [UserController::class, 'store'])->name('users.store');
    Route::delete('divisions/{division}/users/{user}', [UserController::class, 'destroy'])->name('users.destroy');
    Route::get('divisions/{division}/users/{user}/edit', [UserController::class, 'edit'])->name('users.edit');
    Route::post('divisions/{division}/users/{user}', [UserController::class, 'update'])->name('users.update');

    //Holidays
    Route::get('users/{user}/holidays', [HolidayController::class, 'index'])->name('holidays.index');
    Route::post('holidays/{holiday}/reject', [HolidayController::class, 'reject'])->name('holidays.reject');
    Route::post('holidays/{holiday}/approve', [HolidayController::class, 'approve'])->name('holidays.approve');
    Route::get('users/{user}/holidays/create', [HolidayController::class, 'create'])->name('holidays.create');
    Route::post('users/{user}/holidays', [HolidayController::class, 'store'])->name('holidays.store');
    Route::get('users/{user}/holidays/{holiday}/edit', [HolidayController::class, 'edit'])->name('holidays.edit');
    Route::post('users/{user}/holidays/{holiday}', [HolidayController::class, 'update'])->name('holidays.update');
    Route::get('users/{user}/holidays/{holiday}', [HolidayController::class, 'show'])->name('holidays.show');
    Route::delete('users/{user}/holidays/{holiday}', [HolidayController::class, 'destroy'])->name('holidays.destroy');
});



Route::group(['middleware' => 'guest'], function () {
    Route::get('/', [AuthController::class, 'login'])->name('login');
    Route::post('signin', [AuthController::class, 'signin'])->name('signin');
});

app/Models/Division.php
<?php

namespace App\Models;

use App\Models\User;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Database\Eloquent\Factories\HasFactory;

class Division extends Model
{
    use HasFactory;

    protected $fillable = [
        'name',
    ];

    public function users(): HasMany
    {
        return $this->hasMany((User::class));
    }

}

app/Http/Controllers/DivisionController.php
<?php

namespace App\Http\Controllers;

use App\Models\User;
use App\Models\Division;
use Illuminate\Http\Request;
use Illuminate\Validation\Rule;

class DivisionController extends Controller
{

    public function index()
    {
        $this->authorize('viewAny', Division::class);

        return view('divisions/index', [
            'divisions' => Division::get(),
        ]);
    }

    public function create()
    {
        $this->authorize('create', Division::class);

        return view('divisions/create');
    }

    public function store(Request $request)
    {
        $this->authorize('create', Division::class);

        $data = $request->validate([
            'name' => 'required|string',
        ]);

        Division::create($data);

        return to_route('divisions.index');
    }

    public function edit(Division $division)
    {
        $this->authorize('update', $division);

        return view('divisions/edit', [
            'division' => $division
        ]);
    }

    public function update(Request $request, Division $division)
    {
        $this->authorize('update', $division);

        $data = $request->validate([
            'name' => 'required|string',
        ]);

        $division->update($data);

        return to_route('divisions.index');
    }

    public function destroy(Division $division)
    {
        $this->authorize('delete', $division);

        $division->delete();

        return to_route('divisions.index');
    }
}

resources/views/divisions/create.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Divisions</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/water.css@2/out/dark.css">

</head>
<body>
    <h1>New Division</h1>
    <a href="{{ route('divisions.index') }}">Divisions</a> |
    <a href="{{ route('logout') }}">Logout</a>
    <hr>
    <form action="{{ route('divisions.store') }}" method="POST">
        @csrf

        <label for="name">Name</label>
        <input type="text" name="name" id="name">
        <input type="submit" value="Create">
    </form>
</body>
</html>

resources/views/divisions/edit.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Divisions</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/water.css@2/out/dark.css">

</head>
<body>
    <h1>Edit Division</h1>
    <a href="{{ route('divisions.index') }}">Divisions</a> |
    <a href="{{ route('logout') }}">Logout</a>
    <hr>
    <form action="{{ route('divisions.update', ['division' => $division->id]) }}" method="POST">
        @csrf
        @method('put')

        <label for="name">Name</label>
        <input type="text" name="name" id="name" value="{{ $division->name }}">
        <input type="submit" value="Update">
    </form>
</body>
</html>

resources/views/divisions/index.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Divisions</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/water.css@2/out/dark.css">
    <style>
        .delete-btn {padding: 0 !important;display: inline !important;background: transparent !important;color: var(--links) !important;}
        .delete-btn:hover {text-decoration: underline;}
        .delete-form {display: inline !important;vertical-align: middle !important;}
    </style>
</head>
<body>
    <h1>Divisions</h1>
    @can('create', \App\Models\Division::class)
        <a href="{{ route('divisions.create') }}">New Division</a> |
    @endcan
    <a href="{{ route('logout') }}">Logout</a>
    <hr>
    <table>
        <tr>
            <th>Id</th>
            <th>Name</th>
            <th>Actions</th>
        </tr>

        @foreach ($divisions as $division)
        <tr>
            <td>{{ $division->id }}</td>
            <td>{{ $division->name }}</td>
            <td>
                @can('viewAny', [\App\Models\Division::class, $division])
                    <a href="{{ route('users.index', ['division' => $division->id ]) }}">View</a> |
                @endcan
                @can('update', $division)
                    <a href="{{ route('divisions.edit', ['division' => $division->id ]) }}">Edit</a>
                @endcan
                @can('delete', $division)
                    | <form class="delete-form" action="{{ route('divisions.destroy', ['division' => $division->id]) }}" method='post'>
                        @csrf
                        @method('DELETE')
                        <input class="delete-btn" type="submit" value="Delete">
                    </form>
                @endcan
            </td>
        </tr>
        @endforeach

    </table>
</body>
</html>